/**********************************************************************************
* COSC1283/1284 - Programming Techniques
* Semester 1 2013 Assignment #2 - SCSIT Program Management System
* Full Name        : EDIT HERE
* Student Number   : EDIT HERE
* Yallara Username : EDIT HERE
* Course Code      : EDIT HERE
* Program Code     : EDIT HERE
* Start up code provided by Paul Miller and Xiaodong Li
***************************************************************************/

#include "pms.h"
#include "pms_options.h"
#include "pms_utility.h"
#include <stdlib.h>
#include <stdio.h>
#include <regex.h>
#include <glib-2.0/glib.h>
#include <string.h>

#define LINE_LEN 1024
#define COURSE_TOK_LEN 8
#define PROGRAM_TOK_LEN 9

/****************************************************************************
* Function readRestOfLine() is used for buffer clearing. 
* Please refer to "test_fgets.c" on Blackboard: 
* "Course Documents"->"Function Examples"->"Input Validation Examples" 
****************************************************************************/
void readRestOfLine()
{
   int c;

   /* Read until the end of the line or end-of-file. */   
   while ((c = fgetc(stdin)) != '\n' && c != EOF)
      ;

   /* Clear the error and end-of-file flags. */
   clearerr(stdin);
}


/****************************************************************************
* Initialises the system to a safe empty state.
****************************************************************************/
BOOLEAN systemInit(PMSType* pms)
{
    return FALSE;
}


/****************************************************************************
* Loads all data into the system.
****************************************************************************/
BOOLEAN loadData(PMSType* pms, char* programFile, char* courseFile)
{
    CourseType *ctypes = NULL;
    ProgramType *pstypes = NULL;
    size_t toklen =0; /* Initial token count to zero */
    GArray *programArr = NULL; /* Array of struct program_data */
    GArray *courseArr = NULL; /* Array of  struct course_data */
    char block[4]; /* Extract year */
    int counter = 12; /* temp counter */
    struct course_data *data = NULL;
    struct program_data *pdata = NULL;
    char *readlines = NULL; /* Array of characters for each line */
    gchar *toks =NULL;
    gchar ** tok =NULL; /* split each line arrary of string token */
    size_t lines_len = LINE_LEN;
    FILE *prgfile = fopen(programFile,"rb"); /* open program.dat for reading */
    FILE *crsfile = fopen(courseFile,"rb"); /*  open course.dat for reading */
    programArr = g_array_new(FALSE,FALSE,sizeof(struct program_data *)); /* setup  a new temp array which is null termininated  */
    courseArr =  g_array_new(FALSE,FALSE,sizeof(struct course_data *));  /* setup  a new temp array which is null termininated  */
    if(!prgfile || !crsfile)
    {
        return FALSE;
    }
    while(!feof(prgfile))
    {
        if(feof(prgfile)){continue;}
        getline(&readlines,&lines_len,prgfile);
        tok = g_strsplit(readlines,"|",0);
        toklen = g_strv_length(tok) ;
        if(g_strv_length(tok) != PROGRAM_TOK_LEN  )
        {
            fclose(prgfile);
            g_strfreev(tok);
            return FALSE;
        }
        pdata = (struct program_data *)malloc(sizeof(struct program_data));
        if(!pdata){fclose(crsfile);g_strfreev(tok); break;}
        g_strlcpy(pdata->progID,tok[0],ID_LEN + 1);
        g_strlcpy(pdata->progType,tok[1],PROG_TYPE_LEN + 1);
        g_strlcpy(pdata->progMajor,tok[2],MAX_TITLE_LEN + 1);
        g_strlcpy(pdata->progTitle,tok[3],MAX_TITLE_LEN + 1);
        g_strlcpy(pdata->progCode,tok[4],PROG_CODE_LEN+1);
        pdata->progDuration = atof(tok[5]); /* To be fixed later */
        g_strlcpy(pdata->progMode,tok[6],MODE_LEN+1);
        g_strlcpy(pdata->progDescription,tok[7],MAX_DESC_LEN+1);
        g_strlcpy(pdata->majorDescription,tok[8],MAX_DESC_LEN+1);
        g_array_append_val(programArr,pdata);
        g_strfreev(tok);
     }
    fclose(prgfile);
    while(!feof(crsfile))
    {
        if(feof(crsfile)){continue ;}
        getline(&readlines,&lines_len,crsfile);
        tok = g_strsplit(readlines,"|",0);
        if(g_strv_length(tok) != COURSE_TOK_LEN  )
        {
            fclose(crsfile);
            g_strfreev(tok);
            break;
        }
        data = (struct course_data *)malloc(sizeof(struct course_data));
        if(!data){fclose(crsfile);g_strfreev(tok); break;}
        g_strlcpy(data->courseID ,tok[0],ID_LEN + 1);
        g_strlcpy(data->progID ,tok[1],ID_LEN  +1);
        g_strlcpy(data->courseTitle,tok[2],MAX_TITLE_LEN +1 );
        g_strlcpy(data->courseCode,tok[3],COURSE_CODE_LEN + 1);
        data->creditPoints = atoi(tok[4]); /* to be fixed later data validation */
        toks = tok[5];
        data->teachPeriods->semester = atoi(&toks[9]);
        for(int a= 0;a<4;a++)
        {
            block[a] = toks[counter];
            counter++;
        }
        data->teachPeriods->year = atoi(block);
        g_strlcpy(data->courseCoordinator,tok[6],MAX_TITLE_LEN + 1);
        g_strlcpy(data->courseDescription,tok[7],MAX_DESC_LEN + 1);
        g_array_append_val(courseArr,data);
        g_strfreev(tok);
    }  
    fclose(crsfile);
    for(int g=0;g < programArr->len;g++)
    {
    struct program_data * temprogram = (struct program_data *) g_array_index(programArr,struct program_data *,g);
    for(int h=0;h<courseArr->len ; h++)
    {
       struct course_data * tmpcourse = (struct course_data *)g_array_index(courseArr,struct course_data *,h);
       if(strcmp(temprogram->progID,tmpcourse->progID) == 0 )
       {
           ctypes = AppendCourse(tmpcourse,ctypes);
       }
       pstypes = AppendProgram(temprogram,ctypes,pstypes);
       ctypes = NULL;
    }
    }
    
}


/****************************************************************************
* Deallocates memory used in the program.
****************************************************************************/
void systemFree(PMSType* pms)
{
    
}

